/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-10-17 16:34:17.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print;

import cn.com.qmth.examcloud.commons.logging.ExamCloudLog;
import cn.com.qmth.examcloud.commons.logging.ExamCloudLogFactory;
import cn.com.qmth.examcloud.commons.logging.SLF4JImpl;
import cn.com.qmth.examcloud.web.boot.ExamCloudApp;
import org.slf4j.MDC;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.web.support.SpringBootServletInitializer;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.web.multipart.MultipartResolver;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;

/**
 * @author: fengdesheng
 * @since: 2018/10/17
 */
@EnableJpaAuditing
@EnableEurekaClient
@EnableDiscoveryClient
@SpringBootApplication
@EnableTransactionManagement
@ComponentScan(basePackages = {"cn.com.qmth.examcloud"})
@EntityScan(basePackages = {"cn.com.qmth.examcloud"})
@EnableJpaRepositories(basePackages = {"cn.com.qmth.examcloud"})
//@EnableAutoConfiguration(exclude = {MultipartAutoConfiguration.class})
public class PrintApplication extends SpringBootServletInitializer {
    private static final ExamCloudLog LOG = ExamCloudLogFactory.getLog(PrintApplication.class);

    public static void main(String[] args) throws Exception {
        if (LOG instanceof SLF4JImpl) {
            MDC.put("TRACE_ID", Thread.currentThread().getName());
        }
        //SpringApplication.run(PrintApplication.class, args);
        ExamCloudApp.run(PrintApplication.class, "print", args);
    }

    //@Bean(name = "multipartResolver")
    public MultipartResolver multipartResolver() {
        CommonsMultipartResolver resolver = new CommonsMultipartResolver();
        resolver.setDefaultEncoding("UTF-8");
        resolver.setResolveLazily(true);
        resolver.setMaxInMemorySize(50 * 1024);
        resolver.setMaxUploadSize(100 * 1024 * 1024);
        return resolver;
    }

}